<?php 
########################
#                      #
#  ████  █████  █████  #
# ██  ██ ██  ██ ██  ██ #
# ██  ██ ██  ██ ██  ██ #
# ██████ █████  █████  #
# ██  ██ ██     ██     #
# ██  ██ ██     ██     #
# ██  ██ ██     ██     #
#                      #
########################
# version 3.1d xss bugfix
class app{
	private $context;
	private $cfg;
	private $db;
	private $tpl;
	private $secure;
	private $lang;
	private $current_snippets; # array
	private $empty_snippet=[
				'ID'=>'',
				'title'=>'', 
				'tags'=>'', 
				'date'=>'', 
				'timestamp'=>'', 
				'rss_date'=>'', 
				'status'=>'',
				'dependency'=>'', 
				'source'=>'', 
				'content'=>''	
			];
	public function __construct(){
		$session_pack=$this->session('pack');
		if ($session_pack!==false){
			define('SHOW_PACK_BUTTON', 'show_pack_button');
			define('COUNTER', count($session_pack));
		}else{
			define('SHOW_PACK_BUTTON', '');
			define('COUNTER', 0 );
		}
		
		
	}

	public function init(){
		$cfg_format=$this->cfg->getConfigFormat();
		$cfg_format['lang']['other_values']=$this->lang->availableLanguages();
		$cfg_format['theme']['other_values']=array_map('basename',tools::dirFolders(APP_CSS.'themes/'));
		$this->cfg->setConfigFormat($cfg_format);
		$key=$this->cfg->get('json_access_key');
		if (empty($key)){
			$this->cfg->set('json_access_key',tools::generateGUID());
			$this->cfg->save();
		}
		$lang=$this->cfg->get('lang');
		if ($lang){
			$this->lang->setLocale($lang);
		}
		$aspect=$this->cfg->get('snippet_aspect');
		define('SNIPPET_ASPECT',$aspect=='opened'||$this->get('snippet')?'open':'');
	}

	public function get($key){
		if (isset($_GET[$key])){
			return tools::sanitizeText($_GET[$key]);
		}
		return false;
	}
	public function session($key){
		if (isset($_SESSION[$key])){
			return tools::sanitizeData($_SESSION[$key]);
		}
		return false;
	}

	# loadStyles
	# render a stylesheet file <link> foreach css file in current theme folder
	public function loadStyles(){
		$theme=$this->cfg->get('theme');
		$path=APP_CSS."themes/$theme/";
		if (empty($theme)||!is_dir($path)){
			$path=APP_CSS.'themes/default/';
		}
		$css_files=tools::recursiveDirContent($path,'.css');
		$css_links='';
		foreach ($css_files as $css_file) {
			if (is_file($css_file)){
				$css_links.="<link rel='stylesheet' type='text/css' href='$css_file'>\n";
			}
		}
		return $css_links;
	}
/*public function importtags(){
	$tags='{"TODO":2,"ajax":3,"astuce":69,"auto_":2,"bash":1,"bootstrap":14,"conversion":2,"crossbrowser":4,"css":52,"debug":11,"dothtaccess":1,"effets":1,"erreurs":1,"evenements":2,"fallback":1,"fichiers":29,"filter":1,"fonctions":77,"form":2,"graphisme":11,"html":43,"javascript":41,"jquery":27,"lib":2,"mail":1,"markdown":2,"mobile":2,"parser":13,"php":97,"pluXML":5,"python":10,"responsive":8,"securite":17,"social":1,"texte":16,"vanilla":4}';
		$data=[];
		$tags=json_decode($tags,true);
		foreach ($tags as $tag => $nb) {
$data[]=['name'=>$tag,'number'=>$nb];		
}
		$this->db->insert(TABLE_NAME.'_tags',$data);
}*/



###########################################################
#                                                         #
#  ████  ██  ██  ████  █████  █████  ██████ ██████  ████  #
# ██   █ ███ ██   ██   ██  ██ ██  ██ ██     █ ██ █ ██   █ #
#   ██   ██████   ██   █████  █████  █████    ██     ██   #
# █   ██ ██ ███   ██   ██     ██     ██       ██   █   ██ #
#  ████  ██  ██  ████  ██     ██     ██████  ████   ████  #
#                                                         #
###########################################################

	public function importsnippets($path){

		$sndata=json_decode(gzinflate(tools::curlContent($path)),true);
		# import tags
		$data=[];
		foreach ($sndata['tag_list'] as $tag => $nb) {
			$data[]=['name'=>$tag,'number'=>$nb];		
		}//tools::aff($data);
		$this->db->insert(TABLE_NAME.'_tags',$data);

		#import snippets
		unset($sndata['tag_list']);
		$data=[];

		foreach ($sndata as $id=>$snippet) {
			if (empty($snippet['#contenu'])){
				continue;
			}
			$data[]=[
				'ID'=>tools::generateGUID(),
				'title'=>$snippet['#titre'],
				'tags'=>$snippet['#tags'],
				'timestamp'=>strtotime($snippet['#rss_date']),
				'date'=>$snippet['#date'],
				'rss_date'=>$snippet['#rss_date'],
				'status'=>!empty($snippet['#public'])?'public':'private',
				'source'=>$snippet['#adresse'],
				'dependency'=>'',
				'content'=>$snippet['#contenu'],
			];		
		}
		$this->db->insert(TABLE_NAME.'_snippets',$data);
	}

	public function getSnippetData($snippetID=null){
		if (!$snippetID){return $this->empty_snippet;}
		$return=$this->db->search(TABLE_NAME.'_snippets',['ID="'.$snippetID.'"']);
		if (empty($return)){
			$return=$this->empty_snippet;
		}else{$return=$return[0];}

		foreach($return as $key=>$data){
			if (is_string($data)){
				$return[$key]=htmlentities($data);
			}
		}
		if (empty($return['key'])){
			$return['key']=1;
		}


		return $return;
	}

	public function delSnippet($snippetID=null){
		if (!$snippetID){return false;}
		return $this->db->delete(TABLE_NAME.'_snippets',['ID="'.$snippetID.'"']);
	}

	public function isSnippetAllowed($id=null){# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! not tested
		if (!$id){return false;}
		if ($this->secure->connected()){
			return true;
		}

		if (!$this->cfg->get('allow_public_access')){
			return false;
		}

		$data=$this->getSnippetData($id);
		if (
			!$data
			||$data['status']!='public'
		){
			return false;
		}


	}

	public function listSnippets(){
		$this->current_snippets=$this->htmlEntities($this->incrementKeys($this->current_snippets));	
		return $this->tpl->renderForEach('snippet',$this->current_snippets);
	}
	
	public function searchSnippets($search=[]){
		$status='';
		$query='';
		if (!$this->secure->connected()){
			if (!$this->cfg->get('allow_public_access')){
				return false;
			}
			$status='status="public"';
		}
		if (!empty($search['search'])){
			$where='(title LIKE "%'.$search['search'].'%" OR content LIKE "%'.$search['search'].'%")';
		}elseif(!empty($search['tag'])){
			$where='(tags LIKE "%'.$search['tag'].'%")';
		}
		$status=!empty($status)&&!empty($where)?$status.' AND ':$status;
		$query=empty($where)?$status:$status.$where;

		if (empty($query)){
			$result=$this->db->get(TABLE_NAME.'_snippets','*','timestamp DESC');
		}else{
			$result=$this->db->search(TABLE_NAME.'_snippets',$query,'timestamp DESC');
		}
		if (!is_array($search)){
			$result=array_slice($result,0,intval($search));
		}
		$this->current_snippets=!empty($result)?$result:[];
		return $this->current_snippets;
	}

	public function getCurrentSnippets(){
		return $this->current_snippets;
	}

	public function getSnippetsFromUrl(){
		$url=$this->get('url');
		$url=str_replace(['http//','https//'],['http://','https://'],$url);
		$snippet=$this->empty_snippet;
		$snippet['source']=$url;
		$snippet['content']=$this->context['RAW_GET']['code'];
		$snippet['title']=$this->get('title');

		return $snippet;
	}


###############################
#                             #
# ██████  ████   ████   ████  #
# █ ██ █ ██  ██ ██     ██   █ #
#   ██   ██████ ██ ███   ██   #
#   ██   ██  ██ ██  ██ █   ██ #
#  ████  ██  ██  ████   ████  #
#                             #
###############################

	public function updateTags(){
		$snippet_tags=$this->db->get(TABLE_NAME.'_snippets','tags');
		$bd_tags=$this->db->get(TABLE_NAME.'_tags','*');
		$filtered_tags=[];
		foreach($snippet_tags as $key=>$value){ # from 0=>[tags=>"one two"]  to unique tags array [tag=>nb]
			$tags=explode(' ',trim($value['tags']));
			foreach ($tags as $tag) {# increment current tag counter
				if (!empty($tag)){					
					if (isset($filtered_tags[$tag])){
						$filtered_tags[$tag]++;
					}else{
						$filtered_tags[$tag]=1;
					}
				}
			}
		}
		ksort($filtered_tags, SORT_FLAG_CASE+SORT_STRING);
		# here we have the current used tags
		# then make an db compatible array
		$snippet_tags=[];
		foreach ($filtered_tags as $key => $value) {
			$snippet_tags[]=['name'=>$key,'number'=>$value];
		}
		# now update tags db 
		$this->db->insert(TABLE_NAME.'_tags',$snippet_tags);

		# finally delete all tags corresponding to 0 snippets
		if (count($bd_tags)>count($snippet_tags)){
			foreach ($bd_tags as $key => $bd_tag) {
				if (!isset($filtered_tags[$bd_tag['name']])){
					$this->db->delete(TABLE_NAME.'_tags','name="'.$bd_tag['name'].'"');
				}
			}

		}


	}

	public function tagsCloud($snippetID=null){
		$order=$this->cfg->get('sort_by');
		if ($order=='name'){
			$order.=' ASC';
		}else{
			$order.=' DESC';
		}

		if ($snippetID){
			$snippet=$this->getSnippetData($snippetID);
			$tags=explode(',',$snippet['tags]']);
			
		}else{
			$tags=$this->db->get(TABLE_NAME.'_tags','*',$order);
		}
		return $this->tpl->renderForEach('tag',$tags);
	}

	public function tags2link($str=''){
		$tags=explode(' ',$str);
		return $this->tpl->renderForEach('tag_link',$tags);
	}

	public function tagsCheckboxes($current_tags){
		$order=$this->cfg->get('sort_by');
		if ($order=='name'){
			$order.=' ASC';
		}else{
			$order.=' DESC';
		}
		$check=[];
		$tags=$this->db->get(TABLE_NAME.'_tags','*',$order);
		foreach ($tags as $key => $value) {
			if (strpos($current_tags,$value['name'])!==false){
				$checked=' checked';
			}else{
				$checked='';
			}
			$check[]=['name'=>$value['name'],'checked'=>$checked];
		}
		
		return $this->tpl->renderForEach('tag_checkbox',$check);
	}



################################
#                              #
# █     █  ████   ████   ████  #
# ██   ██   ██   ██   █ ██  ██ #
# ███ ███   ██     ██   ██     #
# ██ █ ██   ██   █   ██ ██  ██ #
# ██   ██  ████   ████   ████  #
#                              #
################################
	public function bookmarklet(){
		$bookmarklet=$this->tpl->render('bookmarklet');
		return $bookmarklet;
	}

	public function countResults(){
		return count($this->current_snippets);
	}

	# snippets2Rss
	########################
	# convert results snippets to rss items array
	public function snippets2Rss(){

		$items=[];
		foreach ($this->current_snippets as $key => $snippet) {
			$items[$key]['title']=$snippet['title'];
			$items[$key]['description']=$snippet['content'].'('.$snippet['tags'].')';
			$items[$key]['link']=CURRENT_URL.'?snippet='.$snippet['ID'];
			$items[$key]['guid']=CURRENT_URL.'?snippet='.$snippet['ID'].'#';
			$items[$key]['date']=$snippet['rss_date'];
			$items[$key]['pubDate']=$snippet['rss_date'];
		}
		return $items;
	}	

	# doJsonLink
	########################
	# return a json link for the current page
	public function doJsonLink(){
		if ($this->cfg->get('allow_json_access')!='1'){
			return false;
		}
		return $this->tpl->render('json_link',['link'=>CURRENT_QUERY_URL.'&json&key='.$this->cfg->get('json_access_key')]);
	}

	# doRssLink
	########################
	# return a rss link for the current page
	public function doRssLink(){
		if ($this->cfg->get('allow_rss_feed')!='1'){
			return false;
		}
		return $this->tpl->render('rss_link',['link'=>CURRENT_QUERY_URL.'&rss']);
	}

	public function statusRadios($default=null){
		if (empty($default)){
			$default=$this->cfg->get('default_snippet_status');
		}

		$data=[
			[
				'status'=>'public',
				'checked'=>$default=='public'?'checked':''
			],
			[
				'status'=>'private',
				'checked'=>$default=='private'?'checked':''
			]
		];

		return $this->tpl->renderForEach('status_radio_button',$data);
	}


	private function incrementKeys($array=[]){
		$new_array=[];
		# used to start keys at 1 instead of 0
		foreach ($array as $key => $value) {
			$new_array[$key+1]=$value;
		}
		return $new_array;
	}

	private function htmlEntities($snippets=[]){
		foreach ($snippets as $key => $snippet) {
			$snippets[$key]['content']=htmlentities($snippets[$key]['content']);
		}
		return $snippets;
	}

	public function setContext(&$context=null){			
		$this->context=&$context;
		$this->cfg=tools::getClassInstance($context,'config');
		$this->db=tools::getClassInstance($context,'DB');
		$this->tpl=tools::getClassInstance($context,'tpl');
		$this->secure=tools::getClassInstance($context,'secure');
		$this->lang=tools::getClassInstance($context,'language');

		
	}	
}