<?php
##############################################
#                                            #
# ██  ██ ██████ ████    ████  ██  ██ █     █ #
# ██  ██ ██      ██      ██   ██  ██ ██   ██ #
# ██  ██ ██      ██      ██   ██  ██ ███ ███ #
# ██████ █████   ██      ██   ██  ██ ███████ #
# ██  ██ ██      ██      ██   ██  ██ ██ █ ██ #
# ██  ██ ██      ██ ██   ██   ██  ██ ██   ██ #
# ██  ██ ██████ ██████  ████   ████  ██   ██ #
#                                            #
##############################################
####################################################
#                                                  #
#  ▒▒▒▒   ▒▒▒▒  ▒▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒  ▒▒  ▒▒  ▒▒▒▒  #
# ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ ▒ ▒▒ ▒ ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒     ▒▒  ▒▒ ▒▒  ▒▒   ▒▒   ▒▒     ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒     ▒▒▒▒▒▒ ▒▒▒▒▒    ▒▒   ▒▒     ▒▒▒▒▒▒ ▒▒▒▒▒▒ #
# ▒▒     ▒▒  ▒▒ ▒▒       ▒▒   ▒▒     ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒  ▒▒ ▒▒  ▒▒ ▒▒       ▒▒   ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ #
#  ▒▒▒▒  ▒▒  ▒▒ ▒▒      ▒▒▒▒   ▒▒▒▒  ▒▒  ▒▒ ▒▒  ▒▒ #
#                                                  #
####################################################


/**
 ****************************************
 * Description
 * @name        : Helium_captcha_class.php
 * @Package     : Helium
 * @Author      : Bronco
 * @Description : captcha procedure
 * @Version     : 1.0
 ****************************************
 **/



namespace Helium\classes;
class captcha{
	private $version="1.0";
	private $numbers;
	private $errorMsg='Captcha error';
	private $path='temp/';
	private $current;
	private $html='<div class="captcha"><input type="hidden" value="key" name="captchaKey"><span>string</span> <input type="text" name="captchaResult"/></div>';
	
	public function __construct(){
		for ($nb=51;$nb<61;$nb++){
			$this->numbers[$nb-40]='&#94'.$nb;		
		}
		for ($nb=10122;$nb<10132;$nb++){
			$this->numbers[$nb-10121]='&#'.$nb;		
		}
		if (!is_dir($this->path)){
			mkdir($this->path);
		}
	}

	###########################
	# METHODS #################
	###########################


	# load
	###########################
	
	# handlePost
	# checks if captcha is OK
	public function handlePost(){
       	if (
	       	isset($_POST['captchaKey'])
	       	&&isset($_POST['captchaResult'])
       	){
       		$this->destroy($_POST['captchaKey']);
       		if (
       			empty($_SESSION['captcha'][$_POST['captchaKey']])
       			||$_SESSION['captcha'][$_POST['captchaKey']]!=$_POST['captchaResult']
       			||!is_file($this->path.$_POST['captchaKey'].'.captcha')
       		){
       			exit($this->errorMsg);
       		}
       		
       	}
    }

    public function getVersion(){return $this->version;}



	# generate
	#
	public function generate(){
       	$nb1=rand(1,20);
       	$nb2=rand(1,20);
       	$result=$nb1+$nb2;
       	$key=\tools::generateGUID();
       	$_SESSION['captcha'][$key]=$result;
       	\tools::save($this->path.$key.'.captcha',$result);
       	$this->current['key']=$key;
       	$this->current['string']=$this->numbers[$nb1].'✚'.$this->numbers[$nb2];
    }	

    # destroy
	#
	public function destroy($key=null){
       	if ($key && isset($_SESSION[$key])){
       		unset($_SESSION['captcha'][$key]);
       	}
       	if (is_file($this->path.$key.'.captcha')){
       		@unlink($this->path.$key.'.captcha');
       	}
    }

	# doInput
	#
	public function doInput(){
       	if (
       		empty($this->current)
       	){
       		$this->generate();
       	}
       	return str_replace(array_keys($this->current),array_values($this->current),$this->html);

    }
    public function setErrorMsg($value){
    	$this->errorMsg=$value;
    }

}