<?php
##############################################
#                                            #
# ██  ██ ██████ ████    ████  ██  ██ █     █ #
# ██  ██ ██      ██      ██   ██  ██ ██   ██ #
# ██  ██ ██      ██      ██   ██  ██ ███ ███ #
# ██████ █████   ██      ██   ██  ██ ███████ #
# ██  ██ ██      ██      ██   ██  ██ ██ █ ██ #
# ██  ██ ██      ██ ██   ██   ██  ██ ██   ██ #
# ██  ██ ██████ ██████  ████   ████  ██   ██ #
#                                            #
##############################################
#############################################
#                                           #
#  ░░░░  ░░░░░░  ░░░░  ░░  ░░ ░░░░░  ░░░░░░ #
# ░░  ░░ ░░     ░░  ░░ ░░  ░░ ░░  ░░ ░░     #
#  ░░    ░░     ░░     ░░  ░░ ░░  ░░ ░░     #
#   ░░   ░░░░░  ░░     ░░  ░░ ░░░░░  ░░░░░  #
#    ░░  ░░     ░░     ░░  ░░ ░░  ░░ ░░     #
# ░░  ░░ ░░     ░░  ░░ ░░  ░░ ░░  ░░ ░░     #
#  ░░░░  ░░░░░░  ░░░░   ░░░░  ░░  ░░ ░░░░░░ #
#                                           #
#############################################

/**
 ****************************************
 * Description
 * @name        : Helium_secure_class.php
 * @Package     : Helium
 * @Author      : Bronco
 * @Description : All security process
 * @Version     : 1.0beta8 (last done: bugfix login/pass)
 ****************************************
 **/
namespace Helium\classes;
class secure{
	private $version="1.0beta8";
	private $raw_data=['GET'=>[],'POST'=>[],'FILES'=>[]];
	private $context; # array
	private $tpl; # object reference
	private $users; # object reference
	private $secure_data_folder='./data/secure/'; # string
	private $session_key; # string
	private $salt; # string
	private $auto_sanitize=true; # boolean
	private $check_referrer=true; # boolean
	private $connected_login; # string
	private $connected_email; # string
	private $url_after_login; # string
	private $token; # string
	private $cookie_name='appname'; # string
	private $token_expiration_delay=3600; # seconds/integer
	private $session_expiration_delay=3600; # seconds/integer
	private $ip_ban_expiration_delay=30; # seconds/integer
	private $cookies_expiration_delay=31536000; # seconds/integer (31536000 = 1 calcyear)
	private $bannedIp; # array
	private $domain; # string
	private $email_sent_message='Email sent'; # array
	private $reset_password_link_message='Click on this link to reset your password'; # array
	private $reset_password_mail_message='Reset password email'; # array
	private $login_error_message='Error with login/password'; # array
	private $token_error_message='Error with token'; # array
	private $logout_button='<a href="?logout" class="logout_button">Logout</a>';
	private $login_form='
		<div id="login">
		<h1>Please, login</h1>
		  <div id="form">
		  	<form action="?" method="post">	
		      <div>			        
		        <label>Login</label>
		        <input type="text" name="login" id="login" required="required"/>
		      </div>
		      <div>   
		        <label>Password</label>
		        <input type="password" name="pass" id="pass" required="required"/>
		      </div>
		    	<div>		    	
	          <input id="kouki" type="checkbox" value="cookie" name="cookie" />
	          <label for="kouki" tooltip="Don\'t check on public computers">Stay connected on this device</label>
		       	<input type="hidden" value="#token" name="token"/>
		        <input id="submit" type="submit" value="Ok" name="connect" />	
		    	</div>
		    </form>
		  </div>
		</div>
	';
	private $new_user_form='
		<div id="create_new_user">
		<h1>New account</h1>
		  <div id="form">
		  	<form action="?" method="post" name="">			
		      <div>		        
		        <label>Login</label>
		        <input type="text" name="login" id="login" required="required" autocomplete="false" />  	
		      </div>
			<div>
		        <label>Password</label>
		        <input type="password" name="pass" id="pass" required="required"/>	
		      </div>		  	
		      <div>
		        <label>Email</label>
		        <input type="email" name="email" id="email" required="required" />
		      </div>		      
		      <input type="hidden" value="#token" name="token"/>
		      <input id="submit" type="submit" name="newuser" value="Ok" />	
		    </form>
		  </div>
		</div>

	';
	private $first_user_form='
		<div id="create_first_user">
		<h1>Create the first account</h1>
		  <div id="form">
		  	<form action="?" method="post" name="">			
		      <div>		        
		        <label>Login</label>
		        <input type="text" name="login" id="login" required="required" autocomplete="false" />  	
		      </div>
			<div>
		        <label>Password</label>
		        <input type="password" name="pass" id="pass" required="required"/>	
		      </div>		  	
		      <div>
		        <label>Email</label>
		        <input type="email" name="email" id="email" required="required" />
		      </div>		      
		      <input type="hidden" value="#token" name="token"/>
		      <input id="submit" type="submit" name="firstuser" value="Ok" />	
		    </form>
		  </div>
		</div>

	';
	private $edit_user_form='
		<div id="edit_user">
		<h1>Edit user data</h1>
		  <div id="form">
		  	<form action="?" method="post" name="">			
		      <div>		        
		        <label>Login</label>
		        <input type="text" name="login" id="login" required="required" autocomplete="false" value="#login"/>  	
		      </div>
				<div>
		        <label>Old password</label>
		        <input type="password" name="current_password" id="pass" required="required"/>	
		      </div>
		      <div>
		        <label>New password</label>
		        <input type="password" name="pass" id="pass" required="required"/>	
		      </div>		  	
		      <div>
		        <label>Email</label>
		        <input type="email" name="email" id="email" required="required" value="#email"/>
		      </div>		      
		      <input type="hidden" value="#token" name="token"/>
		      <input id="submit" type="submit" name="edituser" value="Ok" />	
		    </form>
		  </div>
		</div>

	';
	private $reset_password_form='
		<div id="reset_pwd">
		<h1>Reset password</h1>
		  <div id="form">
		  	<form action="?" method="post" name="">			  	
		      <div>
		        <label>Enter your email</label>
		        <input type="email" name="resetemail" id="email" required="required" value="#email" placeholder=""xxxx@xxx.xx"/>
		      </div>		      
		      <input type="hidden" value="#token" name="token"/>
		      <input id="submit" type="submit" name="edituser" value="Ok" />	
		    </form>
		  </div>
		</div>

	';
	private $new_password_form='
		<div id="new_pwd">
		<h1>Reset password</h1>
		  <div id="form">
		  	<form action="?" method="post" name="">			  	
		      <div>
		        <label>Enter your new password</label>
		        <input type="password" name="pass1" required="required" />
		      </div>	
		      <div>
		        <label>Confirm your new password</label>
		        <input type="password" name="pass2" required="required" />
		      </div>		      
		      <input type="hidden" value="#token" name="token"/>
		      <input type="hidden" value="#resetToken" name="resetToken"/>
		      <input id="submit" type="submit" name="newpassword" value="Ok" />	
		    </form>
		  </div>
		</div>

	';
	
	public function __construct($params=null){
		if (!session_id()){session_start();}

		# if config different from default.
		if (!empty($params)){
			foreach ($params as $prop => $value) {
				if (property_exists($this, $prop)){
					$this->$prop=$value;
				}
			}
		}

		if (!is_dir($this->secure_data_folder)){
			# secure folder
			mkdir($this->secure_data_folder,0755);
		}	
		# init secure data/files
		$this->setSecureDataFolder($this->secure_data_folder);
		if (!is_file($this->secure_data_folder.'instance.php')){
			# secure config file 
			$this->save(
				$this->secure_data_folder.'instance.php',
				[
					'INSTANCE_SECURE_SESSION_ID'=>$this->hash(),
					'INSTANCE_SALT'=>$this->generateSalt(),
				]
			);
		}

		if (!is_file($this->secure_data_folder.'users.php')){
			# users file
			$this->save(
				$this->secure_data_folder.'users.php',
				[]
			);
		}		

		if (!is_file($this->secure_data_folder.'bannedIP.php')){
			# bannedIP file
			$this->save(
				$this->secure_data_folder.'bannedIP.php',
				[]
			);
		}		

		if (!is_dir($this->secure_data_folder.'tokens/')){
			# tokens folder
			mkdir($this->secure_data_folder.'tokens/',0755);
		}		

		if (!is_dir($this->secure_data_folder.'cookies/')){
			# tokens folder
			mkdir($this->secure_data_folder.'cookies/',0755);
		}		

		# load Banned Ip array		
		$this->bannedIp=$this->load($this->secure_data_folder.'bannedIP.php');
		# load secure config data
		$data=$this->load($this->secure_data_folder.'instance.php');
		$this->session_key=$data['INSTANCE_SECURE_SESSION_ID'];
		$this->salt=$data['INSTANCE_SALT'];

		$this->cleanTokenFolder();
		$this->cleanSessionTokens();

		# Create the current global token
		$this->returnToken();

		$this->domain=$this->getURL();
		if ($this->auto_sanitize){
			$this->sanitizeGET();
			$this->sanitizePOST();
			$this->sanitizeFILES();
		}

		# if there's POST data, checks the token
		if ($_POST&&!$this->checkToken()){
			# token problem ? -> get out !
			exit($this->token_error_message);
		}
		define('CURRENT_TOKEN',$this->returnToken());
	}


#####################################################
#                                                   #
# ░     ░ ░░░░░░ ░░░░░░ ░░  ░░  ░░░░  ░░░░░   ░░░░  #
# ░░   ░░ ░░     ░ ░░ ░ ░░  ░░ ░░  ░░ ░░  ░░ ░░   ░ #
# ░░░ ░░░ ░░░░░    ░░   ░░░░░░ ░░  ░░ ░░  ░░   ░░   #
# ░░ ░ ░░ ░░       ░░   ░░  ░░ ░░  ░░ ░░  ░░ ░   ░░ #
# ░░   ░░ ░░░░░░  ░░░░  ░░  ░░  ░░░░  ░░░░░   ░░░░  #
#                                                   #
#####################################################
# PRIVATE

	# load
    ###########################
    private function load($file=null){
        return  $file=\tools::load($file);
    }

    # save
    ###########################
    private function save($file=null,$data=null){
        return  \tools::save($file,$data);
    }

    # log
    ###########################
    private function log($str=''){
        if (empty($str)){return false;}
        
        $str=date('d/m/Y h:i:s').' => '.$str."\n";
        file_put_contents($this->secure_data_folder.'logfile.log', $str,FILE_APPEND);
    }

    # redirect
	###########################
	private function redirect($url=null){
		$token='';
		$redirect=$this->getSessionVal('redirect_to');
		$this->setSessionVal('redirect_to',null);
		
		if (!$url && !$redirect){return false;}
		if (!$url && $redirect){$url=$redirect;}

		if (strpos($url,'token=')===false){
			$token='token='.$this->token();
		}
		
		if (strpos($url,'?')!==false&&!empty($token)){
			$token='?'.$token;
		}elseif (!empty($token)){
			$token='&'.$token;
		}

		if (!headers_sent()){header('location: '.$url.$token);}
		else{echo '<script>document.location.href="'.$url.$token.'";</script>';}
		
		exit;
	}

    # sanitize
    ###########################
    private static function sanitize($data=null,$tolerance=0){
        if (is_string($data)){
            return str_replace(array("\0",'\\','[',']','{','}',';',':','$','='),'',strip_tags($data));
        }else if (is_array($data)){
            return array_map('self::sanitize',$data);
        }
        return $data;
    }






# PUBLIC

    public function sanitizeGET(){
    	$this->raw_data['GET']=$_GET;
    	$_GET=\tools::sanitizeData($_GET);
    }
    public function sanitizePOST(){
    	$this->raw_data['POST']=$_POST;
    	$_POST=\tools::sanitizeData($_POST);
    }
    public function sanitizeFILES(){
    	$this->raw_data['FILES']=$_FILES;
    	$_FILES=$this->sanitize($_FILES);
    }

	# lock
	###########################
	# lock access for not connected people
	public function lock(){
		if (!$this->connected()){
			if ($this->users->count()>0){
				$this->setSessionVal('redirect_to',\tools::getUrl().'?'.$_SERVER['QUERY_STRING']);
				$this->redirect('?p=login');
			}else{
				$this->setSessionVal('redirect_to',\tools::getUrl().'?'.$_SERVER['QUERY_STRING']);
				$this->redirect('p=firstuserpage');
			}
		}
	}

	# needToken
	###########################
	# block access if there's no token (public access with token)
	public function needToken($url=null){
		if (!$this->checkToken()){
			if ($url){$this->redirect($url);}
			exit($this->token_error_message);
		}
	}

    # params
    ###########################
    # debug method
    public function params(){
        \tools::aff(array_keys(get_object_vars ($this)));
    }
    
	# logout
	###########################
	public function logout(){
		$this->cleanSessionTokens();
		$this->cleanTokenFolder();
		session_destroy();
		$this->connected_login='';
		$this->connected_email='';
		$this->deleteCookie();
	}

	# login
	###########################
	# try to login a user
	# create the current user & session data
	## $login as string
	## $pass as string
	public function login($login=null,$pass=null){
		$redirect=false;
		# if no cookie, check login request
		$cookie=$this->getCookie();
		if (
			  $login
			&&$pass
		){
			# try to login
			if (
				!$this->checkUserPass($login,$pass)
			){
				$this->banIp();
				$this->log('Login error from '.$_SERVER['REMOTE_ADDR'].': «'.$login.'» & «'.$pass.'»');
				$this->redirect('?p=login&error=Erreur de passe ou de login.');
				exit;
			}

			# stay connected checked ? Create cookie !
			if (!empty($_POST['cookie'])){
				$this->createCookie($login);
			}
			$redirect=true;
		}elseif (
			  !$login
			  &&!$cookie
		){
			$this->loginForm();
		}else{
			$login=$cookie;
		}

		# security attributes 
		$data=$this->users->get($login);

		$this->connected_login		=$login;
		$this->connected_email		=$data['email'];

		# session data
		$this->setSessionVal('sid',$this->distantUserId());		
		$this->setSessionVal('user',['login'=>$this->connected_login,'email'=>$this->connected_email]);
		$this->reviveSession();
		if ($redirect){
			if ($this->url_after_login){
				$this->redirect($this->url_after_login);
			}else{
				$this->redirect('index.php?');
			}
		}
	}

	# connectFromCookie
	###########################	
	private function connectFromCookie(){
		$login=$this->getCookie();		

		# security attributes (if cookie is related to an actual user)
		$data=$this->users->get($login);
		if (empty($data)){
			return false;
		}
		$this->connected_login		=$login;
		$this->connected_email		=$data['email'];

		# session data
		$this->setSessionVal('sid',$this->distantUserId());		
		$this->setSessionVal('user',['login'=>$this->connected_login,'email'=>$this->connected_email]);
		$this->reviveSession();

		# here, let's purge old session token files (once in a session)
		$this->cleanTokenFolder();
		$this->cleanSessionTokens();
	}
	# connectFromSession
	###########################	
	private function connectFromSession(){
		$data=$this->getSessionVal('user');
		$this->connected_login=$data['login'];
		$this->connected_email=$data['email'];
		$this->reviveSession();
	}

	# connected
	###########################
	# checks if a user is connected 
	# Return : boolean
	public function connected(){
		if ($this->checkSession()){
			$this->connectFromSession();
			return true;
		}

		if ($this->checkCookie()){
			$this->connectFromCookie();
		}
		return false;
	}

	# securityCheck
	###########################
	# check all security breaches (referrer etc)
	private function securityCheck($bypassToken=false,$banIp=true){
		if (defined('SECURITY_CHECK')){
			$this->reviveSession();			
			return SECURITY_CHECK;
		}elseif (			
			  ($this->connected()||$this->getCookie())
			&&$this->checkReferrer()
			&&( 
				$bypassToken
				||
				(!$bypassToken&&$this->checkToken() )
			)
			&&$this->checkIp()
		){
			# All security is ok (token included)
			$this->reviveSession();
			define('SECURITY_CHECK',true);
			return true;
		}elseif (	
			  $this->checkSession()
			&&$this->checkToken(null,true)=='token_old'
			&&$this->checkReferrer()
			&&($this->isSessionAlive()||$this->getCookie())
			&&$this->checkIp()
		){

			# All security is ok but token too old
			$get=reset($this->BZN->pg->get());
			if (!empty($get)){
				$refresh_url='index.php?'.$get.'&token='.$this->token;
			}else{
				$refresh_url='index.php?files&token='.$this->token;
			}
			header("location: $refresh_url");
			exit;
		}
		# in case of security problem, ban ip & return false
		if ($banIp){
			$this->banIp();
		}
		define('SECURITY_CHECK',false);

		return false;	
	}


	# checkReferrer
	###########################
	# check the referer
	private function checkReferrer(){
		return (strpos($_SERVER['HTTP_REFERER'], $this->domain) === 0) || !$this->check_referrer;	
	}

	private function hash($string=null,$salt=null){
	    if (!$salt){$salt=$this->generateSalt(1024);}
	    if (!$string||!$salt){$string=uniqid('',true);}
	    return hash('sha512', $salt.$string);
	}
	private function generateSalt($length=512){
	    $salt='';
	    $chars='abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ@-!_';
	    $count=strlen($chars)-1;
	    for($i=1;$i<=$length;$i++){
	        $salt.=$chars[mt_rand(0,$count)];
	    }
	    return $salt;
	}

	private function deleteDir($dir){
        # delete a folder and its content
        if (is_dir($dir)) { 
            $objects = scandir($dir); 
            foreach ($objects as $object) { 
                if ($object != "." && $object != "..") { 
                    if (filetype($dir."/".$object) == "dir") $this->deleteDir($dir."/".$object); else unlink($dir."/".$object); 
                } 
            } 
            reset($objects); 
            rmdir($dir); 
        }       
    }

    private function generatePass($length=10,$method=1){
    	if ($method==1){
	    	$chars='abcdefghijklmnopqrstuvwxyZABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
	    	$pass='';$c=strlen($chars)-1;
	    	for ($i=1;$i<=$length;$i++){
	    		$pass.=$chars[rand(0,$c)];
	    	}
	    }elseif($method==2){
	    	$consonnes='bcdfghjklmnpqrstvwxz';
	    	$voyelles='aeiouy';
	    	$syllabes=[];
	    	for ($consonne=0;$consonne<20;$consonne++){
	    		for ($voyelle=0;$voyelle<6;$voyelle++){
	    			$syllabes[]=$consonnes[$consonne].$voyelles[$voyelle];
	    			$syllabes[]=$voyelles[$voyelle].$consonnes[$consonne];
	    		}
	    	}
	    	$pass='';
	    	$c=count($syllabes)-1;
	    	for ($i=0;$i<$length/2;$i++){
	    		$pass.=$syllabes[rand(0,$c)];
	    	}
	    }
    	return $pass;

    }
#############################################
#                                           #
#  ░░░░   ░░░░   ░░░░  ░░  ░░  ░░░░  ░░░░░░ #
# ░░  ░░ ░░  ░░ ░░  ░░ ░░ ░░    ░░   ░░     #
# ░░     ░░  ░░ ░░  ░░ ░░░░     ░░   ░░░░░  #
# ░░  ░░ ░░  ░░ ░░  ░░ ░░ ░░    ░░   ░░     #
#  ░░░░   ░░░░   ░░░░  ░░  ░░  ░░░░  ░░░░░░ #
#                                           #
#############################################
	#
	# createCookie
	###########################
	private function createCookie($login){
		$id=$this->hash(uniqid(true));
		setCookie($this->cookie_name,$id,time()+$this->cookies_expiration_delay);
		$this->save($this->secure_data_folder.'cookies/'.$id.'.cookie',$login);
	}

	# deleteCookie
	###########################
	private function deleteCookie(){
		if (empty($_COOKIE[$this->cookie_name])){
			return false;
		}
		$id=$_COOKIE[$this->cookie_name];
		setCookie($this->cookie_name);
		if (is_file($this->secure_data_folder.'cookies/'.$id.'.cookie')){
			unlink($this->secure_data_folder.'cookies/'.$id.'.cookie');				
		}
	}

	# getCookie
	###########################
	# return cookie login or false
	private function getCookie(){		
		if ($this->checkCookie()){
			return $this->load($this->secure_data_folder.'cookies/'.$_COOKIE[$this->cookie_name].'.cookie');
		}else{
			$this->deleteCookie();
			return false;
		}
		
		return false;
	}

	# checkCookie
	###########################
	private function checkCookie(){
		return !empty($_COOKIE[$this->cookie_name])&&is_file($this->secure_data_folder.'cookies/'.$_COOKIE[$this->cookie_name].'.cookie');
	}


	# checkUserPass
	###########################
	# check if the pass is correct
	## $pass as string
	## $user as string [optional]
	## Return : boolean
	private function checkUserPass($user=null,$pass=null){

		if (
			  empty($pass)
			||empty($user)
			||!$this->users->count()
			||!$this->users->isLoginUsed($user)
		){
			return false;
		}
		$user=$this->users->get($user);
		$correctpass=$user['pass'];
		$hashed_pass=$this->hash($pass,$user['salt']);
		return $hashed_pass===$correctpass;
	}






######################################
#                                    #
# ░░░░░░  ░░░░  ░░  ░░ ░░░░░░ ░░  ░░ #
# ░ ░░ ░ ░░  ░░ ░░ ░░  ░░     ░░░ ░░ #
#   ░░   ░░  ░░ ░░░░   ░░░░░  ░░░░░░ #
#   ░░   ░░  ░░ ░░ ░░  ░░     ░░ ░░░ #
#  ░░░░   ░░░░  ░░  ░░ ░░░░░░ ░░  ░░ #
#                                    #
######################################

	# checkToken
	###########################
	public function checkToken($token=null,$specify_error=false){
		if (!$token && !empty($_POST['token'])){
			$token=$this->sanitize($_POST['token']);
		}elseif (!$token && !empty($_GET['token'])){
			$token=$this->sanitize($_GET['token']);
		}elseif (!$token){
			# no token specified ? Problem !
			if (!$specify_error){
				return false;
			}else{
				return 'no_token';
			}
		}

		$file=$this->returnTokenFile($token);

		# No token file: >false
		if (empty($file)){
			$this->burnToken($file);
			if (!$specify_error){				
				return false;
			}else{
				return 'no_file_token';
			}
		}

		# Token too old: >false
		if (filemtime($file)+$this->token_expiration_delay<time()){
			$this->burnToken($file);
			if (!$specify_error){				
				return false;
			}else{
				return 'token_old';
			}
		}

		# Session Token does'nt exists
		if (empty($this->getSessionVal('tokens')[$token])){
			$this->burnToken($file);
			if (!$specify_error){				
				return false;
			}else{
				return 'no_session_token';
			}
		}

		$this->burnToken($file);
		return true;
	}
	
	# returnTokenFile
	# return the correct token filepath
	###########################
	private function returnTokenFile($token=null){
		$file  = $this->secure_data_folder.'tokens/'.$token.'.token';
		
		if (is_file($file)){
			return $file;
		}
		return false;
	}
	

	
	# returnToken
	###########################
	# Create & return a security token
	public function returnToken(){
		$token=$this->hash();
		$time=time()+$this->token_expiration_delay;

		# Token into session
		$this->setSessionToken($token,$time);

		# Token file onto server
		file_put_contents($this->secure_data_folder.'tokens/'.$token.'.token',$time);

		# Set current global token
		$this->token=$token;

		# Return token to add it in get/post data
		return $token;
	}

	# inputToken
	###########################
	# return a hidden input token (for forms)
	public function inputToken($token=null){
		if (!$token){$token=$this->token();}
		return '<input value="'.$token.'" name="token" type="hidden">';
	}

	# inputSID
	###########################
	# return a hidden input SID (for forms)
	public function inputSID($sid=null){
		if (!$sid){$sid=$this->getSessionVal('sid');}
		return $sid?'<input value="'.$sid.'" name="SID" type="hidden">':'';
	}

	# cleanTokenFolder
	# delete all OLD token files
	###########################
	private function cleanTokenFolder($all_user_tokens=false){
		$tokens_list=array_merge(glob($this->secure_data_folder.'tokens/*.token'));
		if (empty($tokens_list)){return false;}
		foreach ($tokens_list as $token_file){
			if (
				filemtime($token_file)+$this->token_expiration_delay<time()
				||$all_user_tokens
			){
				$this->burnToken($token_file);
			}
		}
	}

	# cleanSessionTokens
	# delete all old token keys in session
	###########################
	private function cleanSessionTokens(){
		if (empty($_SESSION[$this->session_key]['tokens'])){return;}
		foreach ($_SESSION[$this->session_key]['tokens'] as $key=>$data){
			if ($data<time()){
				$this->burnToken($key);
			}
		}
	}	

	# burnToken
	# destroy a token (file+session)
	###########################
	private function burnToken($token_file=null){
		if (!$token_file){return false;}
		$token=false;

		$file_val='';

		if (stripos($token_file,'.token')!==false){			
			$token=explode('.',basename($token_file))[0];
		}

		if (is_file($token_file)){
			unlink($token_file);
		}

		if ($token&&!empty($_SESSION['tokens'][$token])){
			unset($_SESSION['tokens'][$token]);
		}
	}
	



	# confirmPass
	###########################
	# return an input to confirm a sensitive form with the user pass
	public function confirmPass(){
		return '<input id="current_password" class="current_password" name="current_password" type="password" required="true">';
	}

	# currentPassCheck
	###########################
	# check if adminpass is ok
	private function currentPassCheck(){
		if (empty($_POST['current_password'])||empty($this->user['salt'])){return false;}
		if ($this->hash($_POST['current_password'],$this->user['salt'])!=$$this->user['pass']){
			return false;
		}
		return true;
	}




#################
#               #
#  ░░░░  ░░░░░  #
#   ░░   ░░  ░░ #
#   ░░   ░░░░░  #
#   ░░   ░░     #
#  ░░░░  ░░     #
#               #
#################


	# checkIp
	###########################
	## $ip as string [optional]
	private function checkIp($ip=null){
		if(empty($ip)){$ip=$_SERVER['REMOTE_ADDR'];}
		if (isset($this->bannedIp[$ip])){
			if($this->bannedIp[$ip]['nb']<=5){
				return true;
			}
			elseif($this->bannedIp[$ip]['date']>=@date('U')){# active banishment
				return false;
			}elseif($this->bannedIp[$ip]['date']<@date('U')){# remove banishment
				$this->unbanIp($ip);
				return true;
			} 
		}
		return true;
	}

	# banIp
	###########################
	## $ip as string [optional]
	## Return : Null
	private function banIp($ip=null){
		if (!$this->checkIp()){return false;}
		if(empty($ip)){$ip=$_SERVER['REMOTE_ADDR'];}
		if (isset($this->bannedIp[$ip])){
			$this->bannedIp[$ip]['nb']++;
		}else{
			$this->bannedIp[$ip]['nb']=1;
		}
		$this->bannedIp[$ip]['date']=date('U')+$this->ip_ban_expiration_delay;
		$this->save($this->secure_data_folder.'bannedIP.php',$this->bannedIp);
	}

	# unbanIp
	###########################
	## $ip as string [optional]
	## Return : Null
	private function unbanIp($ip=null){
		if(empty($ip)){$ip=$_SERVER['REMOTE_ADDR'];}
		if (isset($this->bannedIp[$ip])){
			unset($this->bannedIp[$ip]);
		}
		$this->save($this->secure_data_folder.'bannedIP.php',$this->bannedIp);
	}


	# distantUserId
	###########################
	# return a id string for the user
	public function distantUserId(){
		$id=$_SERVER['REMOTE_ADDR'];
		$id.='-'.$_SERVER['HTTP_USER_AGENT'];
		$id.='-'.session_id();
		return $this->hash($id,$this->salt);	
	}

####################################################
#                                                  #
#  ░░░░  ░░░░░░  ░░░░   ░░░░   ░░░░   ░░░░  ░░  ░░ #
# ░░   ░ ░░     ░░   ░ ░░   ░   ░░   ░░  ░░ ░░░ ░░ #
#   ░░   ░░░░░    ░░     ░░     ░░   ░░  ░░ ░░░░░░ #
# ░   ░░ ░░     ░   ░░ ░   ░░   ░░   ░░  ░░ ░░ ░░░ #
#  ░░░░  ░░░░░░  ░░░░   ░░░░   ░░░░   ░░░░  ░░  ░░ #
#                                                  #
####################################################
	# setSessionVal
	###########################	
	private function setSessionVal($index=null,$val=null){
		if (
			  isset($index)
			&&isset($val)			
		){
			$_SESSION[$this->session_key][$index]=$this->sanitize($val);
		}else{
			return false;
		}
	}
	# getSessionVal
	###########################
	private function getSessionVal($index=null){
		if (
			!empty($index)
			&&isset($_SESSION[$this->session_key][$index])
		){
			return $this->sanitize($_SESSION[$this->session_key][$index]);
		
		}else{
			return false;
		}
	}	
	# setSessionToken
	###########################	
	private function setSessionToken($token=null,$val=null){
		if (
			  isset($token)
			&&isset($val)			
		){
			$_SESSION[$this->session_key]['tokens'][$token]=$this->sanitize($val);
		}else{
			return false;
		}
	}
	# getSessionToken
	###########################
	private function getSessionToken($token=null){
		if (
			!empty($token)
			&&isset($_SESSION[$this->session_key][$token])
		){
			return $this->sanitize($_SESSION[$this->session_key]['tokens'][$token]);
		
		}else{
			return false;
		}
	}	
	# reviveSession
	###########################
	private function reviveSession(){
		$this->setSessionVal('expire',@date('U')+$this->session_expiration_delay);
	}	

	# checkSession
	###########################
	# check all security session vars & compare to users base 
	private function checkSession(){		
		$session_user=$this->getSessionVal('user');
		if ($session_user){
			if (
				!session_id()
				||!$this->getSessionVal('sid')
				||$this->getSessionVal('sid')!=$this->distantUserId()
				||empty($session_user['login'])
				||!$this->users->get($session_user['login'])
				||empty($_SESSION[$this->session_key])
				||!$this->getSessionVal('expire')
				||$this->getSessionVal('expire')<date('U')
			){				
				return false;
			}
			return true;
		}	
		return false;
	}

######################################
#                                    #
# ░░  ░░  ░░░░  ░░░░░░ ░░░░░   ░░░░  #
# ░░  ░░ ░░   ░ ░░     ░░  ░░ ░░   ░ #
# ░░  ░░   ░░   ░░░░░  ░░░░░    ░░   #
# ░░  ░░ ░   ░░ ░░     ░░  ░░ ░   ░░ #
#  ░░░░   ░░░░  ░░░░░░ ░░  ░░  ░░░░  #
#                                    #
######################################

	# updateSessionUserData
	###########################
	# update session (if changes applied to connected user)
	private function updateSessionUserData($login=null,$data=null){
		if (
			  !$login
			||empty($data)
			||$login!=$this->connected_login
		){
			return false;
		}
		
		$user_data=$this->users->get($login);
		unset($user_data['salt'],$user_data['pass']);

		# session			
		$this->setSessionVal('user',$user_data);
		$this->reviveSession();

		# here, let's purge old session token files (once in a session)
		$this->cleanTokenFolder();
		
	}




#######################################
#                                     #
# ░░░░░░  ░░░░  ░░░░░  ░     ░  ░░░░  #
# ░░     ░░  ░░ ░░  ░░ ░░   ░░ ░░   ░ #
# ░░░░░  ░░  ░░ ░░░░░  ░░░ ░░░   ░░   #
# ░░     ░░  ░░ ░░  ░░ ░░ ░ ░░ ░   ░░ #
# ░░      ░░░░  ░░  ░░ ░░   ░░  ░░░░  #
#                                     #
#######################################
	# render a security form & try to use tpl class instance if exists in context
	private function render($element,$data=[]){
		if (empty($this->tpl)){
			$this->tpl=\tools::getClassInstance($this->context,'tpl');
		}
		if ($this->tpl){        		
			return $this->tpl->render($element,$data);
		}elseif(!empty($this->$element)){
			return str_replace(array_keys($data),array_values($data),$this->$element);
		}
	}

	public function loginForm($exit=false){	
		$echo=$this->render('login_form',['#token'=>$this->token]);
		if ($exit){exit($echo);}
		return $echo;
	}

	public function createUserForm($exit=false){
		$echo=$this->render('new_user_form',['#token'=>$this->token]);
		if ($exit){exit($echo);}
		return $echo;
	}

	public function firstUserForm($exit=false){
		$echo=$this->render('first_user_form',['#token'=>$this->token]);
		if ($exit){exit($echo);}
		return $echo;
	}

	public function resetPasswordForm($exit=false){
		$echo=$this->render('reset_password_form',['#token'=>$this->token,'#email'=>'']);
		if ($exit){exit($echo);}
		return $echo;
	}

	public function newPasswordForm($exit=false,$resetToken=''){
		$echo=$this->render('new_password_form',['#token'=>$this->token,'#resetToken'=>$resetToken]);
		if ($exit){exit($echo);}
		return $echo;
	}

	public function editUserForm($exit=false){
		$echo=$this->render('edit_user_form',['#token'=>$this->token,'#login'=>$this->connected_login,'#email'=>$this->connected_email]);
		if ($exit){	exit($echo);}
		return $echo;
	}

	public function logoutLink($exit=false){
		$echo=$this->render('logout_button');
		if ($exit){	exit($echo);}
		return $echo;
	}

	public function loginLogoutButton($exit=false){
		if ($this->connected()){
			$button='logout_button';
		}else{
			$button='login_button';
		}
		$echo=$this->render($button);
		if ($exit){	exit($echo);}
		return $echo;
	}


	public function getURL($domain_only=true){
        $url = @( $_SERVER["HTTPS"] != 'on' ) ? 'http://'.$_SERVER["SERVER_NAME"] : 'https://'.$_SERVER["SERVER_NAME"];
        if(!$domain_only){
        	$url .= $_SERVER["SCRIPT_NAME"];
        }
        return $url;
    }

########################
#                      #
#  ░░░░  ░░░░░░ ░░░░░░ #
# ░░     ░░     ░ ░░ ░ #
# ░░ ░░░ ░░░░░    ░░   #
# ░░  ░░ ░░       ░░   #
#  ░░░░  ░░░░░░  ░░░░  #
#                      #
########################

    public function handleGet(){
    	if ($_GET){
    		if (isset($_GET['logout'])){
    			$this->logout();
    			header('location: index.php');
    		}
    		if (isset($_GET['resetpass'])){
    			$this->resetPasswordForm(false);
    		}
    		if (isset($_GET['newtoken'])&&$this->securityCheck(true)){
    			exit($this->returnToken());
    		}
    		# resetpass link clicked 
    		if(
    			  !empty($_GET['resetToken'])
    			  && !empty($_SESSION[$_GET['resetToken']])
    			  && $this->users->get($_SESSION[$_GET['resetToken']])
    		){
    			
    			$this->newPasswordForm(false,$_GET['resetToken']);
    		}

    	}
    }


###############################
#                             #
# ░░░░░   ░░░░   ░░░░  ░░░░░░ #
# ░░  ░░ ░░  ░░ ░░   ░ ░ ░░ ░ #
# ░░░░░  ░░  ░░   ░░     ░░   #
# ░░     ░░  ░░ ░   ░░   ░░   #
# ░░      ░░░░   ░░░░   ░░░░  #
#                             #
###############################
    public function handlePost(){
    	if ($_POST){
    		# PUBLIC 
    		####################
    		# create first user
    		if(
    			  !empty($_POST['email'])
    			&&!empty($_POST['login'])
    			&&!empty($_POST['pass'])
    			&&!empty($_POST['firstuser'])
    			&&$this->users->count()==0
    		){
    			# add the first user
    			unset($_POST['firstuser']);
    			unset($_POST['token']);
    			$this->users->addUser($_POST);
    			$_POST=[];
    			return;
    		}

    		# login 
    		if(
    			  !empty($_POST['login'])
    			&&!empty($_POST['pass'])
    			&&!empty($_POST['connect'])
    		){
    			$this->login($_POST['login'],$_POST['pass']);
    			$_POST=[];
    			return;
    		}

    		# resetpass request 
    		if(
    			  !empty($_POST['resetemail'])
    		){
    			foreach ($this->users as $user => $data) {
    				if ($data['email']==$_POST['resetemail']){
    					$email=$data['email'];
    					break;
    				}
    			}
    			if (!empty($email)){
	    			# create token 
	    			$resetToken=$this->generatePass(100,1);
	    			# create link
	    			$link='<a href="'.$this->getURL(false).'?resetToken='.$resetToken.'">'.$this->reset_password_link_message.'</a>';
	    			# send email with reset link
	    			$_SESSION[$resetToken]=$user;
    			}
    			echo $this->email_sent_message.$link;
    			return;
    		}

    		# resetpass link clicked 
    		if(
    			  !empty($_POST['pass1'])
    			  && !empty($_POST['pass2'])
    			  && $_POST['pass2']==$_POST['pass1']
    			  && !empty($_POST['resetToken'])
    			  && !empty($_SESSION[$_POST['resetToken']])
    			  && $this->users->get($_SESSION[$_POST['resetToken']])
    		){
    			$this->changeUserData('pass',$_POST['pass1'],$_SESSION[$_POST['resetToken']],true);
    			echo ('ok!');
    			$this->loginForm(false);
    		}


    		# ADMIN
    		####################
    		if (!$this->securityCheck()){ return false;}
    		if(
    			  !empty($_POST['email'])
    			&&!empty($_POST['login'])
    			&&!empty($_POST['pass'])
    			&&!empty($_POST['newuser'])
    		){
    			# add a new user
    			unset($_POST['newuser']);
    			unset($_POST['token']);
    			$this->users->addUser($_POST);
    		}
    		if(
    			  !empty($_POST['login'])
    			&&!empty($_POST['deluser'])
    		){
    			# delete user
    			unset($_POST['deluser']);
    			unset($_POST['token']);
    			$this->users->deleteUser($_POST['deluser']);
    		}
    		if(
    			  !empty($_POST['email'])
    			&&!empty($_POST['login'])
    			&&!empty($_POST['current_password'])
    			&&!empty($_POST['pass'])
    			&&!empty($_POST['edituser'])
    			&&$this->checkUserPass($this->connected_login,$_POST['current_password'])
    		){
    			# edit a user
    			unset($_POST['edituser']);
    			unset($_POST['current_password']);
    			unset($_POST['token']);
    			$this->users->changeUserData($_POST['login'],$_POST);	
    			$this->updateSessionUserData($_POST['login'],$_POST);
    		}
    	}
    }


	###########################
	# SETTERS #################
	###########################
	public function setContext(&$context=null){					
		$this->context=&$context;
		$this->tpl=\tools::getClassInstance($this->context,'tpl');
		$this->users=\tools::getClassInstance($this->context,'users');
		$this->connected();
	}	
	private function setConnectedLogin($value=null){			$this->connected_login=$value;}
	private function setConnectedEmail($value=null){			$this->connected_email=$value;}
	private function setToken($value=null){						$this->token=$value;}	
	public function setCookieName($value=null){				$this->$this->cookie_name=$value;}	
	public function setDomain($value=null){						$this->domain=$value;}	
	public function setLogoutButton($value=null){				$this->logout_button=$value;}	
	public function setLoginForm($value=null){					$this->login_form=$value;}	
	public function setRedirectUrl($value=null){				$this->url_after_login=$value;}	
	public function setNewUserForm($value=null){				$this->new_user_form=$value;}	
	public function setFirstUserForm($value=null){			$this->first_user_form=$value;}	
	public function setResetPasswordForm($value=null){		$this->reset_password_form=$value;}	
	public function setNewPasswordForm($value=null){			$this->new_password_form=$value;}	
	public function setEmailSentMessage($value=null){			$this->email_sent_message=$value;}	
	public function setResetPasswordLinkMessage($value=null){$this->reset_password_link_message=$value;}	
	public function setResetPasswordMailMessage($value=null){$this->reset_password_mail_message=$value;}	
	public function setTokenErrorMessage($value=null){		$this->token_error_message=$value;}	
	public function setLoginErrorMessage($value=null){		$this->login_error_message=$value;}	
	public function setAutoSanitize($value=null){					$this->auto_sanitize=$value;}	
	public function setCheckReferrer($value=null){		    	$this->check_referrer=$value;}	
	public function setSecureDataFolder($path=null){
		if ($path&&!is_string($path)){
			trigger_error('Value must be string',E_USER_WARNING);
			return;
		}
		if (is_dir($this->secure_data_folder)&&!is_dir($path)){
			rename($this->secure_data_folder,$path);
		}
		$this->secure_data_folder=$path;
		if (!is_dir($path)){mkdir($path,0755);}
	}

	###########################
	# GETTERS #################
	###########################
	public function getDomain(){			return $this->domain;}
	public function getConnectedLogin(){	return $this->connected_login;}
	public function getConnectedEmail(){	return $this->connected_email;}
	public function token(){				return $this->token;}
	public function getVersion(){			return $this->version;}
	public function getRawGET(){			return $this->raw_data['GET'];}
	public function getRawPOST(){			return $this->raw_data['POST'];}
	public function getRawFILES(){			return $this->raw_data['FILES'];}

}
