<?php
#######################################
#                                     #
#  ████  █   ██ █████  ██████ ██   ██ #
#   ██   ██  ██ ██  ██ ██     ██   ██ #
#   ██   ███ ██ ██  ██ ██      ██ ██  #
#   ██   ██████ ██  ██ █████    ███   #
#   ██   ██ ███ ██  ██ ██      ██ ██  #
#   ██   ██  ██ ██  ██ ██     ██   ██ #
#  ████  ██   █ █████  ██████ ██   ██ #
#                                     #
#######################################

/**
 ****************************************
 * Description
 * @name        : index.php
 * @Package     : Helium
 * @Author      : Bronco
 * @Description : seriously (°_°) ?
 * @Version     : 1.2 (added initInstances & sanitizeFiles)
 ****************************************
 **/

###############################
#                             #
#  ▒▒▒▒  ▒▒  ▒▒  ▒▒▒▒  ▒▒▒▒▒▒ #
#   ▒▒   ▒▒▒ ▒▒   ▒▒   ▒ ▒▒ ▒ #
#   ▒▒   ▒▒▒▒▒▒   ▒▒     ▒▒   #
#   ▒▒   ▒▒ ▒▒▒   ▒▒     ▒▒   #
#  ▒▒▒▒  ▒▒  ▒▒  ▒▒▒▒   ▒▒▒▒  #
#           Context           #
###############################
require_once('data/config/constants.php');
require_once(PHP.'load_classes.php');
require_once(PHP.'functions.php');
define('CURRENT_URL',tools::getURL());
define('CURRENT_QUERY_URL',CURRENT_URL.'?'.$_SERVER['QUERY_STRING']);
define('BROWSER_TYPE',tools::isMobile());

# instanciation
$context=[]; # $context contains referencies for the dependency injection in tpl class
$context['RAW_GET']=$_GET;
$context['RAW_POST']=$_POST;
$context['RAW_FILES']=$_FILES;
tools::sanitizeGet();
tools::sanitizePost();
tools::sanitizeFiles();

if (USE_THUMBNAILS) 			{
	$thumbs  =new \Helium\classes\thumbs();
	$context['thumbs']=&$thumbs;
}
if (USE_RSS) 			{
	$rss  =new \Helium\classes\rss();
	$context['rss']=&$rss;
}
if (USE_CACHE) 			{
	$cache  =new \Helium\classes\cache();
	$context['cache']=&$cache;
}
if (USE_LOCALE) 		{
	$lang 	 =new \Helium\classes\language();
	$context['lang']=&$lang;
}
if (USE_SECURE) 		{
	$users =new \Helium\classes\users();
	$context['users']=&$users;
	$secure =new \Helium\classes\secure(['cookie_name'=>APP_NAME]);
	$context['secure']=&$secure;	
}
if (USE_DB) 			{
	require_once(CONFIG.'db_config.php');
	$db 	 =new \Helium\classes\DB($db,FILES_DB_NAME,$tables);	
	$context['db']=&$db;
}
if (USE_CFG) 			{
	require_once(CONFIG.'config_format.php');
	$cfg 	 =new \Helium\classes\config(CONFIG,$config_format);	
	$context['cfg']=&$cfg;
}
if (USE_TEMPLATE) 		{
	$tpl 	 =new \Helium\classes\TPL([HTML,APP_HTML]);
	$context['tpl']=&$tpl;
}
if (USE_CAPTCHA) 		{
	$captcha 	=new \Helium\classes\captcha();
	$context['captcha']=&$captcha;
}
if (USE_REST) 			{
	$rest 	=new \Helium\classes\REST();
	require_once(APP_PHP.'serverREST.php');
}

require_once(CONFIG.'config.php');
# Add your instances to the context (see the app/php/contex.php file)
require_once(APP_PHP.'context.php');

tools::setInstancesContext($context); # inject the dependencies context into the instances.
tools::initInstances($context); 	  # launch init method in the instances.
tools::handlePostInstances($context); # & handle post/get data destinated to classes (if a class has methods handlePost() or handleGet(), they will be called)

# Application's post & get data 
require_once(APP_PHP.'handlePostData.php');
require_once(APP_PHP.'handleGetData.php');
$tpl->echo('header');
$tpl->echo($page);// $page defined in handleGetData
$tpl->echo('footer');

